(* B: Le module Common c'est le gros bordel y a absolument de tout et
   de n'importe quoi: je vais tenter une reorganisation du module en question!

   T: boooh, tout de suite les grands mots :-)
*)


(* Various completion flags... *)
let check_only = ref false

(** Verbose level: 
   - 0: number of completion steps and number of transitions
        + epsi to add

   - 1: level 0 + the value of transitions to add

   - 2: level 1 + the name and position of applied rules and equations
                + result of normalisation
                + result of merging

   - 3: level 2 + many internal structures are printed
*)
let verbose = ref 0


(** Flag for merging epsilon loops *)
let merge_loop = ref false

(** Printing son relations in dot export *)
let dotson = ref false

(** Exporting without epsilon transitions *)
let export = ref false

(** Pattern matching on final states only or not *)
let subpattern = ref true

(** Exact completion mode: add a renamed copy of the initial tree
    automaton for an exact normalization of new transitions using the
    prior strategy
*)
let exact_completion = ref false

(** Wait users hit enter after each completion step and each refinement step *)
let interactive = ref false

let start_time = ref 0.0
let rclosure_time = ref 0.0
let approx_time = ref 0.0


type strategy = Prior | New
let completion_strategy = ref Prior


type comptype = Noepsi | Epsi
let completion_type = ref Epsi


type approxtype = None | Equationnal
let approx_type = ref Equationnal


(* B: C'est interessant... il y a 2 types presque isomorphes pour definir
   la propriete ! Je n'ai pas encore compris pourquoi.... *)
type proptype = Automata of string | Patterns
let property_type = ref Patterns


let autname = ref ""


(*B: maxsymb c'est un minimum.... hummm :-) *)
(* maxsymb corresponds to the minimal size of the hashtable mapping symbols
   to state vectors. This size is initially small but we make use of
   dynamic resize of Hashtable *)

(* Maximum initial number of constant symbols in a specification *)
(* Different from the value used in Transitions Hashtables *)
let max_symb = 20
let max_state_symb = 20

(* maximum of states for all lhs*)
let max_rule_node = 50
let max_trans = 50
let max_var = 10
let max_equation = 10
let max_condition = 10



IFDEF TEST THEN
let max_state_symb = 8
END

IFDEF TEST THEN
verbose := 10;
(* merge_loop := true *)
END

