#include <bdd.h>

main(void)
{
  bdd x,y,z,u,v,w,p;
  
  bdd_init(1000,100);
  bdd_setvarnum(4);
  
  x = bdd_ithvar(0);
  y = bdd_ithvar(1);
  z = bdd_ithvar(2);
  u = bdd_ithvar(3);
  
  v = bdd_addref(bdd_apply(x,y,bddop_and));
  w = bdd_addref(bdd_apply(z,u,bddop_and));
  p = bdd_addref(bdd_apply(v,w,bddop_or));

  bdd_printtable(p);

  void allSatPrintHandler(char* varset, int size){
    int v;
    for (v=0; v <size; ++v){
      if (varset[v] <0) 
                 printf("X");
      else 
        if (varset[v]==0) printf("0");
        else printf("1");
    }
    printf("\n");
  }

  
  bdd_allsat(p, allSatPrintHandler);
  bdd_delref(p);
  bdd_done();
}
